rc revision 1.139
1#	$NetBSD: rc,v 1.139 2000/01/04 05:20:51 lukem Exp $
2#	originally from: @(#)rc	8.2 (Berkeley) 3/17/94
3
4# System startup script run by init on autoboot
5# or after single-user.
6# Output and error are redirected to console by init,
7# and the console is the controlling terminal.
8
9stty status '^T'
10
11# Set shell to ignore SIGINT (2), but not children;
12# shell catches SIGQUIT (3) and returns to single user after fsck.
13trap : 2
14trap : 3	# shouldn't be needed
15
16export HOME=/
17export PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/X11R6/bin
18
19# Configure ccd devices.
20if [ -f /etc/ccd.conf ]; then
21	ccdconfig -C
22fi
23
24# Configure raid devices.
25for dev in 0 1 2 3; do
26	if [ -f /etc/raid$dev.conf ]; then
27		raidctl -c /etc/raid$dev.conf raid$dev
28	fi
29done
30
31# Add all block-type swap devices; these might be necessary
32# during disk checks.
33swapctl -A -t blk
34
35if [ -e /fastboot ]; then
36	echo "Fast boot: skipping disk checks."
37elif [ "$1" = autoboot ]; then
38	echo "Automatic boot in progress: starting file system checks."
39	fsck -p
40	case $? in
41	0)
42		;;
43	2)
44		exit 1
45		;;
46	4)
47		echo "Rebooting..."
48		reboot
49		echo "Reboot failed; help!"
50		exit 1
51		;;
52	8)
53		echo "Automatic file system check failed; help!"
54		exit 1
55		;;
56	12)
57		echo "Boot interrupted."
58		exit 1
59		;;
60	130)
61		# interrupt before catcher installed
62		exit 1
63		;;
64	*)
65		echo "Unknown error; help!"
66		exit 1
67		;;
68	esac
69fi
70
71trap "echo 'Boot interrupted.'; exit 1" 3
72
73umount -a >/dev/null 2>&1
74mount /
75rm -f /fastboot		# XXX (root now writeable)
76
77if [ -f /etc/rc.subr ]; then
78	. /etc/rc.subr
79else
80	echo "Can't read /etc/rc.subr; aborting."
81	exit 1;
82fi
83
84if [ -f /etc/rc.conf ]; then
85	. /etc/rc.conf
86fi
87
88if ! checkyesno rc_configured; then
89	echo "/etc/rc.conf is not configured. Multiuser boot aborted."
90	exit 1
91fi
92
93# set flags on ttys.  (do early, in case they use tty for SLIP in netstart)
94echo 'setting tty flags'
95ttyflags -a
96
97# load kernel modules specified in /etc/lkm.conf if the /usr filesystem
98# is already present with "/" or can be mounted now
99if checkyesno lkm && [ -f /etc/rc.lkm ]; then
100	mount /usr >/dev/null 2>&1
101	if [ -x /usr/bin/ld ]; then
102		lkmstage=BEFORENET
103		. /etc/rc.lkm
104	fi
105fi
106
107mount_critical_filesystems local
108
109if [ -e /etc/etc.current ] ; then
110	if [ -h /etc/etc.default ] ; then
111		def=`ls -ld /etc/etc.default 2>&1`
112		default=`expr "$def" : '.*-> etc\.\(.*\)' 2>&1`
113	else
114		default=current
115	fi
116	spc=""
117	conflist=`cd /etc; ls -1d etc.* 2>&1 | egrep -v 'current|default'`
118	for i in $conflist; do
119		name=`expr $i : 'etc\.\(.*\)' 2>&1`
120		if [ $name = $default ] ; then
121			echo -n "${spc}[${name}]"
122		else
123			echo -n "${spc}${name}"
124		fi
125		spc=" "
126	done
127	echo
128	master=$$
129	conf=/etc/passwd
130	while [ ! -d /etc/etc.$conf ] ; do
131		trap 'conf=$default; echo; echo Using default of $conf' 14
132		echo -n "Which configuration [$default] ? "
133		(sleep 30 && kill -ALRM $master) >/dev/null 2>&1 &
134		read conf
135		trap "" 14
136		if [ -z $conf ] ; then
137			conf=$default
138		fi
139		if [ ! -d /etc/etc.$conf -a ! -h /etc/etc.$conf ] ; then
140			conf=/etc/passwd
141		fi
142	done
143	rm -f /etc/etc.current
144	ln -s /etc/etc.$conf /etc/etc.current
145	if [ -f /etc/rc.conf ] ; then
146		. /etc/rc.conf
147	fi
148fi
149
150# set hostname, turn on network
151echo 'starting network'
152sh /etc/netstart
153if [ $? -ne 0 ]; then
154	exit 1
155fi
156
157mount_critical_filesystems network
158
159# Network Address Translation...
160if checkyesno ipnat && [ -f /etc/ipnat.conf ]; then
161	echo 'installing NAT rules ... '
162	if ! checkyesno ipfilter || [ ! -f /etc/ipf.conf ]; then
163		ipf -E -Fa
164	fi
165	ipnat -F -f /etc/ipnat.conf
166fi
167
168# "Critical" file systems are now mounted.  Go ahead and swap
169# to files now, since they will be residing in the critical file
170# systems (or, at least, better).
171swapctl -A -t noblk
172
173# Check for no swap, and warn about it unless that is desired.
174if ! checkyesno no_swap; then
175	swapctl -s | grep 'no swap devices configured' > /dev/null && \
176		echo "WARNING:  no swap space configured!"
177fi
178
179# clean up left-over files
180rm -f /etc/nologin
181rm -f /var/spool/lock/LCK.*
182rm -f /var/spool/uucp/STST/*
183(cd /var/run && { rm -rf -- *; install -c -m 664 -g utmp /dev/null utmp; })
184
185# build ps databases
186echo 'building databases...'
187# if this kernel supports machdep.booted_kernel, use that to build the KVM
188# db so dmesg will run work when we boot /netbsd.new, etc.
189sysctl machdep 2>/dev/null | grep -q booted_kernel
190if [ $? -eq 0 ] ; then
191        kvm_mkdb `sysctl -n machdep.booted_kernel`
192	if [ $? -ne 0 ] ; then
193		kvm_mkdb /netbsd
194	fi
195else
196	kvm_mkdb /netbsd
197fi
198dev_mkdb
199
200# get the system dmesg output, hopefully containing the boot messages
201# $dmesg_flags is imported from /etc/rc.conf
202if checkyesno dmesg; then
203	dmesg $dmesg_flags > /var/run/dmesg.boot
204fi
205
206if checkyesno wscons && [ -f /etc/rc.wscons ]; then
207	echo 'configuring wscons'
208	/bin/sh /etc/rc.wscons $wscons_flags
209fi
210
211# start the system logger first, so that all messages from daemons
212# are logged, then start savecore to get a dump on low memory systems
213# and then start the name server.
214
215if checkyesno syslogd; then
216	echo 'starting system logger'
217	# Transitional symlink for old binaries
218	if [ ! -h /dev/log ] ; then
219		ln -sf /var/run/log /dev/log
220	fi
221	rm -f /var/run/log
222	syslogd $syslogd_flags
223fi
224
225# Enable ipmon (only useful if ipfilter is running)
226# NOTE: requires the IPFILTER_LOG kernel option.
227if checkyesno ipmon; then
228	echo 'starting ipmon'
229	ipmon $ipmon_flags &
230fi
231
232# /var/crash should be a directory or a symbolic link
233# to the crash directory if core dumps are to be saved.
234if checkyesno savecore; then
235	if [ -d /var/crash/. ]; then
236		echo checking for core dump...
237		savecore $savecore_flags /var/crash
238	else
239		logger -s "WARNING: no /var/crash directory; savecore not run."
240	fi
241fi
242
243if checkyesno named; then
244	echo 'starting name server';	named $named_flags
245fi
246
247# set time, if requested
248if checkyesno ntpdate; then
249	if [ -z "$ntpdate_hosts" ]; then
250		ntpdate_hosts=`awk '
251		    /^server[ \t]*127.127/	{next}
252		    /^(server|peer)/			{print $2}
253		' </etc/ntp.conf`
254	fi
255	if [ -n "$ntpdate_hosts"  ]; then
256		echo 'Setting date via ntp.'
257		ntpdate -b -s $ntpdate_hosts
258	fi
259fi
260
261# now start the rpc servers, for YP server/client.
262echo -n 'starting rpc daemons:'
263
264# note that portmap is generally required for all other rpc services.
265if checkyesno portmap; then
266	echo -n ' portmap';             portmap $portmap_flags
267fi
268
269if checkyesno ypserv; then
270	checkyesno portmap || \
271	logger -s "WARNING: set portmap=YES in /etc/rc.conf if ypserv=YES."
272
273        echo -n ' ypserv';              ypserv $ypserv_flags
274fi
275
276if checkyesno ypbind; then
277        echo -n ' ypbind';              ypbind $ypbind_flags
278fi
279
280if checkyesno yppasswdd; then
281	checkyesno ypserv || \
282	logger -s "WARNING: set ypserv=YES in /etc/rc.conf if yppasswdd=YES."
283
284        echo -n ' rpc.yppasswdd';       rpc.yppasswdd $yppasswdd_flags
285fi
286
287if checkyesno bootparamd; then
288	if [ -r /etc/bootparams ]; then
289		echo -n ' rpc.bootparamd'; rpc.bootparamd $bootparamd_flags
290	else
291		echo
292		logger -s "WARNING: /etc/bootparams not found. " \
293		    "bootparamd not started."
294	fi
295fi
296
297echo '.'
298
299# load kernel modules specified in /etc/lkm.conf
300if checkyesno lkm; then
301	if [ -r /etc/rc.lkm ]; then
302		lkmstage=BEFOREMOUNT
303		. /etc/rc.lkm
304	else
305		logger -s "WARNING: /etc/rc.lkm not found; LKMs not loaded."
306	fi
307fi
308
309mount -a
310
311# now start the rpc servers, for NFS server/client.
312if checkyesno nfs_client || checkyesno nfs_server; then
313	echo -n 'starting nfs daemons:'
314
315	if checkyesno nfs_server && ! checkyesno portmap; then
316		logger -s "WARNING: set portmap=YES in /etc/rc.conf if nfs_server=YES."
317	fi
318
319	nfs_locking=NO
320
321	if checkyesno nfs_server; then
322		if [ -r /etc/exports ]; then
323			rm -f /var/db/mountdtab
324			echo -n > /var/db/mountdtab
325			echo -n ' mountd';              mountd $mountd_flags
326			echo -n ' nfsd';                nfsd $nfsd_flags
327			nfs_locking=YES
328		else
329			echo
330			logger -s "WARNING: /etc/exports not readable; " \
331			    "NFS server not started."
332		fi
333	fi
334
335	if checkyesno nfs_client; then
336		echo -n ' nfsiod';              nfsiod $nfsiod_flags
337		nfs_locking=YES
338	fi
339
340	if checkyesno nfs_locking; then
341		if checkyesno statd; then
342			echo -n ' rpc.statd';		rpc.statd $statd_flags
343		fi
344		if checkyesno lockd; then
345			echo -n ' rpc.lockd';		rpc.lockd $lockd_flags
346		fi
347	fi
348
349	if checkyesno amd; then
350		if [ -d "$amd_dir" ]; then
351			if [ -r "$amd_master" ]; then
352				echo -n ' amd'
353				amd $amd_flags -p -a $amd_dir \
354				`sed s/#.*$// <$amd_master`  >/var/run/amd.pid
355			else
356				echo
357				logger -s "WARNING: \$amd_master ($amd_master)not " \
358				    "readable; amd not started."
359			fi
360		else
361			echo
362			logger -s "WARNING: \$amd_dir ($amd_dir) not a directory; " \
363			    "amd not started."
364		fi
365	fi
366	echo '.'
367fi
368
369
370if [ -f /sbin/ldconfig ]; then
371	echo 'creating runtime link editor directory cache.'
372	ldconfig
373fi 
374
375# load kernel modules specified in /etc/lkm.conf
376if checkyesno lkm && [ -f /etc/rc.lkm ]; then
377	lkmstage=AFTERMOUNT
378	. /etc/rc.lkm
379fi
380
381# if $defcorename is set, change it here.
382if [ -n "$defcorename" ]; then
383	echo -n 'setting default core name template: '
384	sysctl -w kern.defcorename=$defcorename
385fi
386
387# if $securelevel is set, change it here, else if it is 0, change
388# it to 1 here, before we start login services.
389if [ -n "$securelevel" ]; then
390	echo -n 'setting securelevel: '
391	sysctl -w kern.securelevel=$securelevel
392else
393	securelevel=`sysctl -n kern.securelevel`
394	if [ x"$securelevel" = x0 ]; then
395		echo -n 'setting securelevel: '
396		sysctl -w kern.securelevel=1
397	fi
398fi
399
400echo -n 'checking quotas:'; quotacheck -a; echo ' done.'
401quotaon -a
402
403chmod 666 /dev/tty[pqrs]*
404
405# check the password temp/lock file
406if [ -f /etc/ptmp ]
407then
408	logger -s -p auth.err \
409	'password file may be incorrect -- /etc/ptmp exists'
410fi
411
412# XXX replace me with a script that works!
413virecovery=`echo /var/tmp/vi.recover/recover.*`
414if [ "$virecovery" != "/var/tmp/vi.recover/recover.*" ]; then
415	echo preserving editor files
416	for i in $virecovery; do
417		if [ -f $i ]; then
418			sendmail -t < $i
419		fi
420	done
421fi
422
423echo clearing /tmp
424
425# Prune quickly with one rm, then use find to clean up /tmp/[lq]* (this
426# is not needed with mfs /tmp, but doesn't hurt anything).
427(cd /tmp && rm -rf [a-km-pr-zA-Z]* &&
428    find . ! -name . ! -name lost+found ! -name quota.user \
429	! -name quota.group -exec rm -rf -- {} \; -type d -prune)
430
431# Update kernel info in /etc/motd
432# Must be done *before* interactive logins are possible to prevent
433# possible race conditions.
434if checkyesno update_motd; then
435	echo 'updating motd.'
436	if [ ! -f /etc/motd ]; then
437		install -c -o root -g wheel -m 664 /dev/null /etc/motd
438	fi
439	T=/etc/_motd
440	rm -f $T
441	sysctl -n kern.version | sed 1q > $T
442	echo "" >> $T
443	sed '1,/^$/d' < /etc/motd >> $T
444	cmp -s $T /etc/motd || cp $T /etc/motd
445	rm -f $T
446fi
447
448if checkyesno accounting; then
449	if [ -f /var/account/acct ]; then
450		echo 'turning on accounting'
451		accton /var/account/acct
452	else
453		echo
454		logger -s "WARNING: /var/account/acct doesn't exist; " \
455		    "accounting not enabled."
456	fi
457fi
458
459echo -n standard daemons:
460if checkyesno cron; then
461	echo -n ' cron';		cron
462fi
463echo '.'
464
465# now start all the other daemons
466echo -n starting network daemons:
467
468if checkyesno gated && checkyesno routed; then
469	echo
470	logger -s "WARNING: gated and routed both requested to be run: " \
471	    "running only gated."
472	routed=NO
473fi
474
475if checkyesno gated; then
476	if [ -r /etc/gated.conf ]; then
477		echo -n ' gated';		gated $gated_flags
478	else
479		logger -s "WARNING: no /etc/gated.conf; gated not started."
480	fi
481fi
482
483if checkyesno routed; then
484	echo -n ' routed';		routed $routed_flags
485fi
486
487if checkyesno mrouted; then
488	echo -n ' mrouted';		mrouted $mrouted_flags
489fi
490
491if checkyesno route6d; then
492	echo -n ' route6d';		route6d $route6d_flags
493fi
494
495if checkyesno rtsold; then
496	if checkyesno ip6forwarding; then
497		logger -s "WARNING: rtsold cannot be used on IPv6 router."
498	else
499		echo -n ' rtsold';	rtsold $rtsold_flags
500	fi
501fi
502
503if checkyesno rtadvd; then
504	if checkyesno ip6forwarding; then
505		echo -n ' rtadvd';	rtadvd $rtadvd_flags
506	else
507		logger -s "WARNING: rtadvd cannot be used on IPv6 host."
508	fi
509fi
510
511if checkyesno timed; then
512	echo -n ' timed'; 		timed $timed_flags
513fi
514
515if checkyesno xntpd; then
516	echo -n ' xntpd';		xntpd $xntpd_flags
517fi
518
519if checkyesno dhcpd; then
520	if [ -r /etc/dhcpd.conf ]; then
521		echo -n ' dhcpd';		dhcpd $dhcpd_flags
522	else
523		echo
524		logger -s "WARNING: /etc/dhcpd.conf not readable; " \
525		    "dhcpd not started."
526	fi
527elif checkyesno dhcrelay; then
528	echo -n ' dhcrelay';            dhcrelay $dhcrelay_flags
529fi
530
531if checkyesno rwhod; then
532	echo -n ' rwhod';		rwhod
533fi
534
535if checkyesno lpd; then
536	echo -n ' lpd';			lpd $lpd_flags
537fi
538
539# We call sendmail with a full path so that SIGHUP works.
540if checkyesno sendmail; then
541	if [ -r /etc/sendmail.cf ]; then
542		echo -n ' sendmail';	/usr/sbin/sendmail $sendmail_flags
543	else
544		echo
545		logger -s "WARNING: /etc/sendmail.cf not readable; " \
546		    "sendmail not started."
547	fi
548fi
549
550# Start xfs before boot daemons, so its ready before client xterminals.
551if checkyesno xfs; then
552	echo -n ' xfs';			xfs $xfs_flags
553	sleep 2
554fi
555
556if checkyesno rarpd; then
557	if [ -r /etc/ethers ]; then
558		echo -n ' rarpd';	rarpd $rarpd_flags
559	else
560		echo
561		logger -s "WARNING: /etc/ethers not readable; " \
562		    "rarpd not started."
563	fi
564fi
565
566if checkyesno rbootd; then
567	if [ -r /etc/rbootd.conf ]; then
568		echo -n ' rbootd';	rbootd $rbootd_flags
569	else
570		echo
571		logger -s "WARNING: /etc/rbootd.conf not readable; " \
572		    "rbootd not started."
573	fi
574fi
575
576if checkyesno mopd; then
577	echo -n ' mopd';		mopd $mopd_flags
578fi
579
580if checkyesno apmd; then
581	echo -n ' apmd';		apmd $apmd_flags
582fi
583
584if checkyesno screenblank; then
585	echo -n ' screenblank';		screenblank $screenblank_flags
586fi
587
588if checkyesno inetd; then
589	if [ -r /etc/inetd.conf ]; then
590		echo -n ' inetd';	inetd $inetd_flags
591	else
592		echo
593		logger -s "WARNING: /etc/inetd.conf not readable; " \
594		    "inetd not started."
595	fi
596fi
597
598echo '.'
599
600# Kerberos runs ONLY on the Kerberos server machine
601if checkyesno kerberos; then
602	echo -n 'starting kerberos daemons:'
603	echo -n ' kerberos';	kerberos >> /var/log/kerberos.log &
604	echo -n ' kadmind';	kadmind -n >> /var/log/kadmind.log &
605	echo '.'
606fi
607
608# xdm after wscons - need a virtual screen for X
609if checkyesno xdm; then
610	echo 'starting xdm'
611	xdm $xdm_flags
612fi
613
614. /etc/rc.local
615
616date
617exit 0
618